#include "atmosphere_abilityHandler.h"
#include "atmosphere_triggerHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value) {
	switch(abilityHandleId) {
		case ATMO_ABILITY(Interval, trigger):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_trigger(value, &Interval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Interval, triggered), &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(Interval, setup):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_setup(value, &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(Interval, interval):
		{
			ATMO_Value_t Interval_Value;
			ATMO_InitValue(&Interval_Value);
			Interval_interval(value, &Interval_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Interval, interval), &Interval_Value);
			ATMO_FreeValue(&Interval_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, trigger):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_trigger(value, &BLE_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_TVOC, triggered), &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, setup):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_setup(value, &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, setValue):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_setValue(value, &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, written):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_written(value, &BLE_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_TVOC, written), &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, subscibed):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_subscibed(value, &BLE_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_TVOC, subscibed), &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(BLE_TVOC, unsubscribed):
		{
			ATMO_Value_t BLE_TVOC_Value;
			ATMO_InitValue(&BLE_TVOC_Value);
			BLE_TVOC_unsubscribed(value, &BLE_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_TVOC, unsubscribed), &BLE_TVOC_Value);
			ATMO_FreeValue(&BLE_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, trigger):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_trigger(value, &AirQuality_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_TVOC, triggered), &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, setup):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_setup(value, &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, setEnabled):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_setEnabled(value, &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, setDisabled):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_setDisabled(value, &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, setEnabledDisabled):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_setEnabledDisabled(value, &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, readTVOC):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_readTVOC(value, &AirQuality_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_TVOC, TVOCRead), &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_TVOC, readCO2):
		{
			ATMO_Value_t AirQuality_TVOC_Value;
			ATMO_InitValue(&AirQuality_TVOC_Value);
			AirQuality_TVOC_readCO2(value, &AirQuality_TVOC_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_TVOC, CO2Read), &AirQuality_TVOC_Value);
			ATMO_FreeValue(&AirQuality_TVOC_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, trigger):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_trigger(value, &AirQuality_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_CO2, triggered), &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, setup):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_setup(value, &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, setEnabled):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_setEnabled(value, &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, setDisabled):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_setDisabled(value, &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, setEnabledDisabled):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_setEnabledDisabled(value, &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, readTVOC):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_readTVOC(value, &AirQuality_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_CO2, TVOCRead), &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(AirQuality_CO2, readCO2):
		{
			ATMO_Value_t AirQuality_CO2_Value;
			ATMO_InitValue(&AirQuality_CO2_Value);
			AirQuality_CO2_readCO2(value, &AirQuality_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AirQuality_CO2, CO2Read), &AirQuality_CO2_Value);
			ATMO_FreeValue(&AirQuality_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, trigger):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_trigger(value, &BLE_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_CO2, triggered), &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, setup):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_setup(value, &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, setValue):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_setValue(value, &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, written):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_written(value, &BLE_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_CO2, written), &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, subscibed):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_subscibed(value, &BLE_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_CO2, subscibed), &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(BLE_CO2, unsubscribed):
		{
			ATMO_Value_t BLE_CO2_Value;
			ATMO_InitValue(&BLE_CO2_Value);
			BLE_CO2_unsubscribed(value, &BLE_CO2_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_CO2, unsubscribed), &BLE_CO2_Value);
			ATMO_FreeValue(&BLE_CO2_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, trigger):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_trigger(value, &Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure, triggered), &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, setup):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_setup(value, &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, setEnabled):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_setEnabled(value, &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, setDisabled):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_setDisabled(value, &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, setEnabledDisabled):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_setEnabledDisabled(value, &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, readAltitude):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_readAltitude(value, &Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure, altitudeRead), &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, readPressure):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_readPressure(value, &Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure, pressureRead), &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Pressure, readPressureKpa):
		{
			ATMO_Value_t Pressure_Value;
			ATMO_InitValue(&Pressure_Value);
			Pressure_readPressureKpa(value, &Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Pressure, pressureReadKpa), &Pressure_Value);
			ATMO_FreeValue(&Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, trigger):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_trigger(value, &BLE_Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Pressure, triggered), &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, setup):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_setup(value, &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, setValue):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_setValue(value, &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, written):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_written(value, &BLE_Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Pressure, written), &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, subscibed):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_subscibed(value, &BLE_Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Pressure, subscibed), &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Pressure, unsubscribed):
		{
			ATMO_Value_t BLE_Pressure_Value;
			ATMO_InitValue(&BLE_Pressure_Value);
			BLE_Pressure_unsubscribed(value, &BLE_Pressure_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Pressure, unsubscribed), &BLE_Pressure_Value);
			ATMO_FreeValue(&BLE_Pressure_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, trigger):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_trigger(value, &Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature, triggered), &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, setup):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_setup(value, &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, setEnabled):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_setEnabled(value, &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, setDisabled):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_setDisabled(value, &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, setEnabledDisabled):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_setEnabledDisabled(value, &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, readTemperature):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_readTemperature(value, &Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature, temperatureRead), &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Temperature, readHumidity):
		{
			ATMO_Value_t Temperature_Value;
			ATMO_InitValue(&Temperature_Value);
			Temperature_readHumidity(value, &Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Temperature, humidityRead), &Temperature_Value);
			ATMO_FreeValue(&Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, trigger):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_trigger(value, &BLE_Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Temperature, triggered), &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, setup):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_setup(value, &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, setValue):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_setValue(value, &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, written):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_written(value, &BLE_Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Temperature, written), &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, subscibed):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_subscibed(value, &BLE_Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Temperature, subscibed), &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Temperature, unsubscribed):
		{
			ATMO_Value_t BLE_Temperature_Value;
			ATMO_InitValue(&BLE_Temperature_Value);
			BLE_Temperature_unsubscribed(value, &BLE_Temperature_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Temperature, unsubscribed), &BLE_Temperature_Value);
			ATMO_FreeValue(&BLE_Temperature_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, trigger):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_trigger(value, &Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humidity, triggered), &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, setup):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_setup(value, &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, setEnabled):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_setEnabled(value, &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, setDisabled):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_setDisabled(value, &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, setEnabledDisabled):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_setEnabledDisabled(value, &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, readTemperature):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_readTemperature(value, &Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humidity, temperatureRead), &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(Humidity, readHumidity):
		{
			ATMO_Value_t Humidity_Value;
			ATMO_InitValue(&Humidity_Value);
			Humidity_readHumidity(value, &Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Humidity, humidityRead), &Humidity_Value);
			ATMO_FreeValue(&Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, trigger):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_trigger(value, &BLE_Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Humidity, triggered), &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, setup):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_setup(value, &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, setValue):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_setValue(value, &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, written):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_written(value, &BLE_Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Humidity, written), &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, subscibed):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_subscibed(value, &BLE_Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Humidity, subscibed), &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Humidity, unsubscribed):
		{
			ATMO_Value_t BLE_Humidity_Value;
			ATMO_InitValue(&BLE_Humidity_Value);
			BLE_Humidity_unsubscribed(value, &BLE_Humidity_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Humidity, unsubscribed), &BLE_Humidity_Value);
			ATMO_FreeValue(&BLE_Humidity_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, trigger):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_trigger(value, &AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLight, triggered), &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, setup):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_setup(value, &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, setEnabled):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_setEnabled(value, &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, setDisabled):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_setDisabled(value, &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, setEnabledDisabled):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_setEnabledDisabled(value, &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(AmbientLight, readAmbientLight):
		{
			ATMO_Value_t AmbientLight_Value;
			ATMO_InitValue(&AmbientLight_Value);
			AmbientLight_readAmbientLight(value, &AmbientLight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(AmbientLight, ambientLightRead), &AmbientLight_Value);
			ATMO_FreeValue(&AmbientLight_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, trigger):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_trigger(value, &BLE_Light_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Light, triggered), &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, setup):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_setup(value, &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, setValue):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_setValue(value, &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, written):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_written(value, &BLE_Light_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Light, written), &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, subscibed):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_subscibed(value, &BLE_Light_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Light, subscibed), &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Light, unsubscribed):
		{
			ATMO_Value_t BLE_Light_Value;
			ATMO_InitValue(&BLE_Light_Value);
			BLE_Light_unsubscribed(value, &BLE_Light_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Light, unsubscribed), &BLE_Light_Value);
			ATMO_FreeValue(&BLE_Light_Value);
			break;
		}
		case ATMO_ABILITY(BatteryInfo, trigger):
		{
			ATMO_Value_t BatteryInfo_Value;
			ATMO_InitValue(&BatteryInfo_Value);
			BatteryInfo_trigger(value, &BatteryInfo_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BatteryInfo, triggered), &BatteryInfo_Value);
			ATMO_FreeValue(&BatteryInfo_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, trigger):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_trigger(value, &BLE_Battery_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Battery, triggered), &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, setup):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_setup(value, &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, setValue):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_setValue(value, &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, written):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_written(value, &BLE_Battery_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Battery, written), &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, subscibed):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_subscibed(value, &BLE_Battery_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Battery, subscibed), &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(BLE_Battery, unsubscribed):
		{
			ATMO_Value_t BLE_Battery_Value;
			ATMO_InitValue(&BLE_Battery_Value);
			BLE_Battery_unsubscribed(value, &BLE_Battery_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(BLE_Battery, unsubscribed), &BLE_Battery_Value);
			ATMO_FreeValue(&BLE_Battery_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, trigger):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_trigger(value, &Backlight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Backlight, triggered), &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, setup):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_setup(value, &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, setBacklightOff):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_setBacklightOff(value, &Backlight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Backlight, backlightSet), &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, setBacklightLow):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_setBacklightLow(value, &Backlight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Backlight, backlightSet), &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, setBacklightMedium):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_setBacklightMedium(value, &Backlight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Backlight, backlightSet), &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
		case ATMO_ABILITY(Backlight, setBacklightHigh):
		{
			ATMO_Value_t Backlight_Value;
			ATMO_InitValue(&Backlight_Value);
			Backlight_setBacklightHigh(value, &Backlight_Value);
			ATMO_TriggerHandler(ATMO_TRIGGER(Backlight, backlightSet), &Backlight_Value);
			ATMO_FreeValue(&Backlight_Value);
			break;
		}
	}

}

#ifdef __cplusplus
}
#endif
