
#ifndef ATMO_ABILITY_HANDLER_H
#define ATMO_ABILITY_HANDLER_H

#include "atmosphere_platform.h"
#include "atmosphere_callbacks.h"

#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_ABILITY(ELEMENT, NAME) ATMO_ ## ELEMENT ## _ABILITY_  ## NAME

void ATMO_AbilityHandler(unsigned int abilityHandleId, ATMO_Value_t *value);

#define ATMO_Interval_ABILITY_trigger 0x1
#define ATMO_Interval_ABILITY_setup 0x2
#define ATMO_Interval_ABILITY_interval 0x3
#define ATMO_BLE_TVOC_ABILITY_trigger 0x4
#define ATMO_BLE_TVOC_ABILITY_setup 0x5
#define ATMO_BLE_TVOC_ABILITY_setValue 0x6
#define ATMO_BLE_TVOC_ABILITY_written 0x7
#define ATMO_BLE_TVOC_ABILITY_subscibed 0x8
#define ATMO_BLE_TVOC_ABILITY_unsubscribed 0x9
#define ATMO_AirQuality_TVOC_ABILITY_trigger 0xa
#define ATMO_AirQuality_TVOC_ABILITY_setup 0xb
#define ATMO_AirQuality_TVOC_ABILITY_setEnabled 0xc
#define ATMO_AirQuality_TVOC_ABILITY_setDisabled 0xd
#define ATMO_AirQuality_TVOC_ABILITY_setEnabledDisabled 0xe
#define ATMO_AirQuality_TVOC_ABILITY_readTVOC 0xf
#define ATMO_AirQuality_TVOC_ABILITY_readCO2 0x10
#define ATMO_AirQuality_CO2_ABILITY_trigger 0x11
#define ATMO_AirQuality_CO2_ABILITY_setup 0x12
#define ATMO_AirQuality_CO2_ABILITY_setEnabled 0x13
#define ATMO_AirQuality_CO2_ABILITY_setDisabled 0x14
#define ATMO_AirQuality_CO2_ABILITY_setEnabledDisabled 0x15
#define ATMO_AirQuality_CO2_ABILITY_readTVOC 0x16
#define ATMO_AirQuality_CO2_ABILITY_readCO2 0x17
#define ATMO_BLE_CO2_ABILITY_trigger 0x18
#define ATMO_BLE_CO2_ABILITY_setup 0x19
#define ATMO_BLE_CO2_ABILITY_setValue 0x1a
#define ATMO_BLE_CO2_ABILITY_written 0x1b
#define ATMO_BLE_CO2_ABILITY_subscibed 0x1c
#define ATMO_BLE_CO2_ABILITY_unsubscribed 0x1d
#define ATMO_Pressure_ABILITY_trigger 0x1e
#define ATMO_Pressure_ABILITY_setup 0x1f
#define ATMO_Pressure_ABILITY_setEnabled 0x20
#define ATMO_Pressure_ABILITY_setDisabled 0x21
#define ATMO_Pressure_ABILITY_setEnabledDisabled 0x22
#define ATMO_Pressure_ABILITY_readAltitude 0x23
#define ATMO_Pressure_ABILITY_readPressure 0x24
#define ATMO_Pressure_ABILITY_readPressureKpa 0x25
#define ATMO_BLE_Pressure_ABILITY_trigger 0x26
#define ATMO_BLE_Pressure_ABILITY_setup 0x27
#define ATMO_BLE_Pressure_ABILITY_setValue 0x28
#define ATMO_BLE_Pressure_ABILITY_written 0x29
#define ATMO_BLE_Pressure_ABILITY_subscibed 0x2a
#define ATMO_BLE_Pressure_ABILITY_unsubscribed 0x2b
#define ATMO_Temperature_ABILITY_trigger 0x2c
#define ATMO_Temperature_ABILITY_setup 0x2d
#define ATMO_Temperature_ABILITY_setEnabled 0x2e
#define ATMO_Temperature_ABILITY_setDisabled 0x2f
#define ATMO_Temperature_ABILITY_setEnabledDisabled 0x30
#define ATMO_Temperature_ABILITY_readTemperature 0x31
#define ATMO_Temperature_ABILITY_readHumidity 0x32
#define ATMO_BLE_Temperature_ABILITY_trigger 0x33
#define ATMO_BLE_Temperature_ABILITY_setup 0x34
#define ATMO_BLE_Temperature_ABILITY_setValue 0x35
#define ATMO_BLE_Temperature_ABILITY_written 0x36
#define ATMO_BLE_Temperature_ABILITY_subscibed 0x37
#define ATMO_BLE_Temperature_ABILITY_unsubscribed 0x38
#define ATMO_Humidity_ABILITY_trigger 0x39
#define ATMO_Humidity_ABILITY_setup 0x3a
#define ATMO_Humidity_ABILITY_setEnabled 0x3b
#define ATMO_Humidity_ABILITY_setDisabled 0x3c
#define ATMO_Humidity_ABILITY_setEnabledDisabled 0x3d
#define ATMO_Humidity_ABILITY_readTemperature 0x3e
#define ATMO_Humidity_ABILITY_readHumidity 0x3f
#define ATMO_BLE_Humidity_ABILITY_trigger 0x40
#define ATMO_BLE_Humidity_ABILITY_setup 0x41
#define ATMO_BLE_Humidity_ABILITY_setValue 0x42
#define ATMO_BLE_Humidity_ABILITY_written 0x43
#define ATMO_BLE_Humidity_ABILITY_subscibed 0x44
#define ATMO_BLE_Humidity_ABILITY_unsubscribed 0x45
#define ATMO_AmbientLight_ABILITY_trigger 0x46
#define ATMO_AmbientLight_ABILITY_setup 0x47
#define ATMO_AmbientLight_ABILITY_setEnabled 0x48
#define ATMO_AmbientLight_ABILITY_setDisabled 0x49
#define ATMO_AmbientLight_ABILITY_setEnabledDisabled 0x4a
#define ATMO_AmbientLight_ABILITY_readAmbientLight 0x4b
#define ATMO_BLE_Light_ABILITY_trigger 0x4c
#define ATMO_BLE_Light_ABILITY_setup 0x4d
#define ATMO_BLE_Light_ABILITY_setValue 0x4e
#define ATMO_BLE_Light_ABILITY_written 0x4f
#define ATMO_BLE_Light_ABILITY_subscibed 0x50
#define ATMO_BLE_Light_ABILITY_unsubscribed 0x51
#define ATMO_BatteryInfo_ABILITY_trigger 0x52
#define ATMO_BLE_Battery_ABILITY_trigger 0x53
#define ATMO_BLE_Battery_ABILITY_setup 0x54
#define ATMO_BLE_Battery_ABILITY_setValue 0x55
#define ATMO_BLE_Battery_ABILITY_written 0x56
#define ATMO_BLE_Battery_ABILITY_subscibed 0x57
#define ATMO_BLE_Battery_ABILITY_unsubscribed 0x58
#define ATMO_Backlight_ABILITY_trigger 0x59
#define ATMO_Backlight_ABILITY_setup 0x5a
#define ATMO_Backlight_ABILITY_setBacklightOff 0x5b
#define ATMO_Backlight_ABILITY_setBacklightLow 0x5c
#define ATMO_Backlight_ABILITY_setBacklightMedium 0x5d
#define ATMO_Backlight_ABILITY_setBacklightHigh 0x5e
#ifdef __cplusplus
}
#endif
#endif
