
#ifndef ATMO_CALLBACKS_H
#define ATMO_CALLBACKS_H

#include "atmosphere_platform.h"
#include "atmosphere_properties.h"
#include "atmosphere_variables.h"
#include "atmosphere_triggerHandler.h"
#include "atmosphere_interruptsHandler.h"
#include "atmosphere_embedded_libraries.h"
#include "atmosphere_abilityHandler.h"

#define ATMO_CALLBACK(ELEMENT, NAME) ELEMENT ## _ ## NAME

void ATMO_Setup();

ATMO_Status_t Interval_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Interval_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Interval_interval(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_TVOC_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_readTVOC(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_TVOC_readCO2(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_readTVOC(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AirQuality_CO2_readCO2(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_CO2_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_readAltitude(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_readPressure(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Pressure_readPressureKpa(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Pressure_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_readTemperature(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Temperature_readHumidity(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Temperature_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_readTemperature(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Humidity_readHumidity(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Humidity_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_setEnabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_setDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_setEnabledDisabled(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t AmbientLight_readAmbientLight(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Light_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BatteryInfo_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_setValue(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_written(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_subscibed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t BLE_Battery_unsubscribed(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_trigger(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_setup(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_setBacklightOff(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_setBacklightLow(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_setBacklightMedium(ATMO_Value_t *in, ATMO_Value_t *out);

ATMO_Status_t Backlight_setBacklightHigh(ATMO_Value_t *in, ATMO_Value_t *out);
#endif
