
#ifndef ATMO_INTERRUPTS_HANDLER_H
#define ATMO_INTERRUPTS_HANDLER_H

#ifdef __cplusplus
	extern "C"{
#endif

#include "../atmo/core.h"
#define ATMO_INTERRUPT(ELEMENT, NAME) ATMO_ ## ELEMENT ## _INTERRUPT_  ## NAME

void ATMO_Interval_INTERRUPT_trigger();
void ATMO_Interval_INTERRUPT_setup();
void ATMO_Interval_INTERRUPT_interval();

void ATMO_BLE_TVOC_INTERRUPT_trigger();
void ATMO_BLE_TVOC_INTERRUPT_setup();
void ATMO_BLE_TVOC_INTERRUPT_setValue();
void ATMO_BLE_TVOC_INTERRUPT_written();
void ATMO_BLE_TVOC_INTERRUPT_subscibed();
void ATMO_BLE_TVOC_INTERRUPT_unsubscribed();

void ATMO_AirQuality_TVOC_INTERRUPT_trigger();
void ATMO_AirQuality_TVOC_INTERRUPT_setup();
void ATMO_AirQuality_TVOC_INTERRUPT_setEnabled();
void ATMO_AirQuality_TVOC_INTERRUPT_setDisabled();
void ATMO_AirQuality_TVOC_INTERRUPT_setEnabledDisabled();
void ATMO_AirQuality_TVOC_INTERRUPT_readTVOC();
void ATMO_AirQuality_TVOC_INTERRUPT_readCO2();

void ATMO_AirQuality_CO2_INTERRUPT_trigger();
void ATMO_AirQuality_CO2_INTERRUPT_setup();
void ATMO_AirQuality_CO2_INTERRUPT_setEnabled();
void ATMO_AirQuality_CO2_INTERRUPT_setDisabled();
void ATMO_AirQuality_CO2_INTERRUPT_setEnabledDisabled();
void ATMO_AirQuality_CO2_INTERRUPT_readTVOC();
void ATMO_AirQuality_CO2_INTERRUPT_readCO2();

void ATMO_BLE_CO2_INTERRUPT_trigger();
void ATMO_BLE_CO2_INTERRUPT_setup();
void ATMO_BLE_CO2_INTERRUPT_setValue();
void ATMO_BLE_CO2_INTERRUPT_written();
void ATMO_BLE_CO2_INTERRUPT_subscibed();
void ATMO_BLE_CO2_INTERRUPT_unsubscribed();

void ATMO_Pressure_INTERRUPT_trigger();
void ATMO_Pressure_INTERRUPT_setup();
void ATMO_Pressure_INTERRUPT_setEnabled();
void ATMO_Pressure_INTERRUPT_setDisabled();
void ATMO_Pressure_INTERRUPT_setEnabledDisabled();
void ATMO_Pressure_INTERRUPT_readAltitude();
void ATMO_Pressure_INTERRUPT_readPressure();
void ATMO_Pressure_INTERRUPT_readPressureKpa();

void ATMO_BLE_Pressure_INTERRUPT_trigger();
void ATMO_BLE_Pressure_INTERRUPT_setup();
void ATMO_BLE_Pressure_INTERRUPT_setValue();
void ATMO_BLE_Pressure_INTERRUPT_written();
void ATMO_BLE_Pressure_INTERRUPT_subscibed();
void ATMO_BLE_Pressure_INTERRUPT_unsubscribed();

void ATMO_Temperature_INTERRUPT_trigger();
void ATMO_Temperature_INTERRUPT_setup();
void ATMO_Temperature_INTERRUPT_setEnabled();
void ATMO_Temperature_INTERRUPT_setDisabled();
void ATMO_Temperature_INTERRUPT_setEnabledDisabled();
void ATMO_Temperature_INTERRUPT_readTemperature();
void ATMO_Temperature_INTERRUPT_readHumidity();

void ATMO_BLE_Temperature_INTERRUPT_trigger();
void ATMO_BLE_Temperature_INTERRUPT_setup();
void ATMO_BLE_Temperature_INTERRUPT_setValue();
void ATMO_BLE_Temperature_INTERRUPT_written();
void ATMO_BLE_Temperature_INTERRUPT_subscibed();
void ATMO_BLE_Temperature_INTERRUPT_unsubscribed();

void ATMO_Humidity_INTERRUPT_trigger();
void ATMO_Humidity_INTERRUPT_setup();
void ATMO_Humidity_INTERRUPT_setEnabled();
void ATMO_Humidity_INTERRUPT_setDisabled();
void ATMO_Humidity_INTERRUPT_setEnabledDisabled();
void ATMO_Humidity_INTERRUPT_readTemperature();
void ATMO_Humidity_INTERRUPT_readHumidity();

void ATMO_BLE_Humidity_INTERRUPT_trigger();
void ATMO_BLE_Humidity_INTERRUPT_setup();
void ATMO_BLE_Humidity_INTERRUPT_setValue();
void ATMO_BLE_Humidity_INTERRUPT_written();
void ATMO_BLE_Humidity_INTERRUPT_subscibed();
void ATMO_BLE_Humidity_INTERRUPT_unsubscribed();

void ATMO_AmbientLight_INTERRUPT_trigger();
void ATMO_AmbientLight_INTERRUPT_setup();
void ATMO_AmbientLight_INTERRUPT_setEnabled();
void ATMO_AmbientLight_INTERRUPT_setDisabled();
void ATMO_AmbientLight_INTERRUPT_setEnabledDisabled();
void ATMO_AmbientLight_INTERRUPT_readAmbientLight();

void ATMO_BLE_Light_INTERRUPT_trigger();
void ATMO_BLE_Light_INTERRUPT_setup();
void ATMO_BLE_Light_INTERRUPT_setValue();
void ATMO_BLE_Light_INTERRUPT_written();
void ATMO_BLE_Light_INTERRUPT_subscibed();
void ATMO_BLE_Light_INTERRUPT_unsubscribed();

void ATMO_BatteryInfo_INTERRUPT_trigger();

void ATMO_BLE_Battery_INTERRUPT_trigger();
void ATMO_BLE_Battery_INTERRUPT_setup();
void ATMO_BLE_Battery_INTERRUPT_setValue();
void ATMO_BLE_Battery_INTERRUPT_written();
void ATMO_BLE_Battery_INTERRUPT_subscibed();
void ATMO_BLE_Battery_INTERRUPT_unsubscribed();

void ATMO_Backlight_INTERRUPT_trigger();
void ATMO_Backlight_INTERRUPT_setup();
void ATMO_Backlight_INTERRUPT_setBacklightOff();
void ATMO_Backlight_INTERRUPT_setBacklightLow();
void ATMO_Backlight_INTERRUPT_setBacklightMedium();
void ATMO_Backlight_INTERRUPT_setBacklightHigh();


#ifdef __cplusplus
}
#endif

#endif
