
#ifndef ATMO_PROPERTIES_H
#define ATMO_PROPERTIES_H

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_PROPERTY(ELEMENT, NAME) ATMO_ ## ELEMENT ## _PROPERTY_  ## NAME

#define ATMO_Interval_PROPERTY_errorData NULL
#define ATMO_Interval_PROPERTY_codeUserChanged NULL
#define ATMO_Interval_PROPERTY_instance 0
#define ATMO_Interval_PROPERTY_time 60000

#define ATMO_BLE_TVOC_PROPERTY_errorData NULL
#define ATMO_BLE_TVOC_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_TVOC_PROPERTY_instance 0
#define ATMO_BLE_TVOC_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_TVOC_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f9"
#define ATMO_BLE_TVOC_PROPERTY_read true
#define ATMO_BLE_TVOC_PROPERTY_write false
#define ATMO_BLE_TVOC_PROPERTY_notify true
#define ATMO_BLE_TVOC_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_TVOC_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_TVOC_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_AirQuality_TVOC_PROPERTY_errorData NULL
#define ATMO_AirQuality_TVOC_PROPERTY_codeUserChanged NULL
#define ATMO_AirQuality_TVOC_PROPERTY_i2cInstance 1
#define ATMO_AirQuality_TVOC_PROPERTY_i2cAddress 0x5A
#define ATMO_AirQuality_TVOC_PROPERTY_operatingMode 1

#define ATMO_AirQuality_CO2_PROPERTY_errorData NULL
#define ATMO_AirQuality_CO2_PROPERTY_codeUserChanged NULL
#define ATMO_AirQuality_CO2_PROPERTY_i2cInstance 1
#define ATMO_AirQuality_CO2_PROPERTY_i2cAddress 0x5A
#define ATMO_AirQuality_CO2_PROPERTY_operatingMode 1

#define ATMO_BLE_CO2_PROPERTY_errorData NULL
#define ATMO_BLE_CO2_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_CO2_PROPERTY_instance 0
#define ATMO_BLE_CO2_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_CO2_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336fa"
#define ATMO_BLE_CO2_PROPERTY_read true
#define ATMO_BLE_CO2_PROPERTY_write false
#define ATMO_BLE_CO2_PROPERTY_notify true
#define ATMO_BLE_CO2_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_CO2_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_CO2_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_Pressure_PROPERTY_errorData NULL
#define ATMO_Pressure_PROPERTY_codeUserChanged NULL
#define ATMO_Pressure_PROPERTY_i2cInstance 1
#define ATMO_Pressure_PROPERTY_i2cAddress 0x60
#define ATMO_Pressure_PROPERTY_pressureOffset 0
#define ATMO_Pressure_PROPERTY_altitudeOffset 0
#define ATMO_Pressure_PROPERTY_tempOffset 0

#define ATMO_BLE_Pressure_PROPERTY_errorData NULL
#define ATMO_BLE_Pressure_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_Pressure_PROPERTY_instance 0
#define ATMO_BLE_Pressure_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_Pressure_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336fc"
#define ATMO_BLE_Pressure_PROPERTY_read true
#define ATMO_BLE_Pressure_PROPERTY_write false
#define ATMO_BLE_Pressure_PROPERTY_notify true
#define ATMO_BLE_Pressure_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Pressure_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Pressure_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_Temperature_PROPERTY_errorData NULL
#define ATMO_Temperature_PROPERTY_codeUserChanged NULL
#define ATMO_Temperature_PROPERTY_i2cInstance 1
#define ATMO_Temperature_PROPERTY_i2cAddress 0x43
#define ATMO_Temperature_PROPERTY_tempCalibrationOffset -7

#define ATMO_BLE_Temperature_PROPERTY_errorData NULL
#define ATMO_BLE_Temperature_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_Temperature_PROPERTY_instance 0
#define ATMO_BLE_Temperature_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_Temperature_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336fb"
#define ATMO_BLE_Temperature_PROPERTY_read true
#define ATMO_BLE_Temperature_PROPERTY_write false
#define ATMO_BLE_Temperature_PROPERTY_notify true
#define ATMO_BLE_Temperature_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Temperature_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Temperature_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_Humidity_PROPERTY_errorData NULL
#define ATMO_Humidity_PROPERTY_codeUserChanged NULL
#define ATMO_Humidity_PROPERTY_i2cInstance 1
#define ATMO_Humidity_PROPERTY_i2cAddress 0x43
#define ATMO_Humidity_PROPERTY_tempCalibrationOffset -7

#define ATMO_BLE_Humidity_PROPERTY_errorData NULL
#define ATMO_BLE_Humidity_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_Humidity_PROPERTY_instance 0
#define ATMO_BLE_Humidity_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_Humidity_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336fd"
#define ATMO_BLE_Humidity_PROPERTY_read true
#define ATMO_BLE_Humidity_PROPERTY_write false
#define ATMO_BLE_Humidity_PROPERTY_notify true
#define ATMO_BLE_Humidity_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Humidity_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Humidity_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_AmbientLight_PROPERTY_errorData NULL
#define ATMO_AmbientLight_PROPERTY_codeUserChanged NULL
#define ATMO_AmbientLight_PROPERTY_i2cInstance 1
#define ATMO_AmbientLight_PROPERTY_i2cAddress 0x39

#define ATMO_BLE_Light_PROPERTY_errorData NULL
#define ATMO_BLE_Light_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_Light_PROPERTY_instance 0
#define ATMO_BLE_Light_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_Light_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336fe"
#define ATMO_BLE_Light_PROPERTY_read true
#define ATMO_BLE_Light_PROPERTY_write false
#define ATMO_BLE_Light_PROPERTY_notify true
#define ATMO_BLE_Light_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Light_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Light_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_BatteryInfo_PROPERTY_errorData NULL
#define ATMO_BatteryInfo_PROPERTY_codeUserChanged NULL

#define ATMO_BLE_Battery_PROPERTY_errorData NULL
#define ATMO_BLE_Battery_PROPERTY_codeUserChanged NULL
#define ATMO_BLE_Battery_PROPERTY_instance 0
#define ATMO_BLE_Battery_PROPERTY_bleServiceUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336f8"
#define ATMO_BLE_Battery_PROPERTY_bleCharacteristicUuid "08d41e61-ac11-40a2-a95a-e0e0fb5336ff"
#define ATMO_BLE_Battery_PROPERTY_read true
#define ATMO_BLE_Battery_PROPERTY_write false
#define ATMO_BLE_Battery_PROPERTY_notify true
#define ATMO_BLE_Battery_PROPERTY_readDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Battery_PROPERTY_writeDataType ATMO_DATATYPE_STRING
#define ATMO_BLE_Battery_PROPERTY_notifyDataType ATMO_DATATYPE_STRING

#define ATMO_Backlight_PROPERTY_errorData NULL
#define ATMO_Backlight_PROPERTY_codeUserChanged NULL
#define ATMO_Backlight_PROPERTY_initialSetting BLIGHT_LEVEL_OFF


#ifdef __cplusplus
}
#endif

#endif
