#include "atmosphere_triggerHandler.h"
#include "atmosphere_abilityHandler.h"

#ifdef __cplusplus
	extern "C"{
#endif

void ATMO_TriggerHandler(unsigned int triggerHandleId, ATMO_Value_t *value) {
	switch(triggerHandleId) {
		case ATMO_TRIGGER(Interval, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Interval, interval):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(AirQuality_TVOC, readTVOC), value);
			ATMO_AbilityHandler(ATMO_ABILITY(AirQuality_CO2, readCO2), value);
			ATMO_AbilityHandler(ATMO_ABILITY(Pressure, readPressure), value);
			ATMO_AbilityHandler(ATMO_ABILITY(Temperature, readTemperature), value);
			ATMO_AbilityHandler(ATMO_ABILITY(Humidity, readHumidity), value);
			ATMO_AbilityHandler(ATMO_ABILITY(AmbientLight, readAmbientLight), value);
			ATMO_AbilityHandler(ATMO_ABILITY(BatteryInfo, trigger), value);
			break;
		}

		case ATMO_TRIGGER(BLE_TVOC, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_TVOC, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_TVOC, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_TVOC, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(AirQuality_TVOC, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(AirQuality_TVOC, TVOCRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_TVOC, setValue), value);
			break;
		}

		case ATMO_TRIGGER(AirQuality_TVOC, CO2Read):
		{
			break;
		}

		case ATMO_TRIGGER(AirQuality_CO2, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(AirQuality_CO2, TVOCRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_CO2, setValue), value);
			break;
		}

		case ATMO_TRIGGER(AirQuality_CO2, CO2Read):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_CO2, setValue), value);
			break;
		}

		case ATMO_TRIGGER(BLE_CO2, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_CO2, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_CO2, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_CO2, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure, altitudeRead):
		{
			break;
		}

		case ATMO_TRIGGER(Pressure, pressureRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Pressure, setValue), value);
			break;
		}

		case ATMO_TRIGGER(Pressure, pressureReadKpa):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Pressure, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Pressure, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Pressure, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Pressure, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Temperature, temperatureRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Temperature, setValue), value);
			break;
		}

		case ATMO_TRIGGER(Temperature, humidityRead):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Temperature, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Temperature, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Temperature, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Temperature, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Humidity, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Humidity, temperatureRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Humidity, setValue), value);
			break;
		}

		case ATMO_TRIGGER(Humidity, humidityRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Humidity, setValue), value);
			break;
		}

		case ATMO_TRIGGER(BLE_Humidity, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Humidity, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Humidity, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Humidity, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(AmbientLight, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(AmbientLight, ambientLightRead):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Light, setValue), value);
			break;
		}

		case ATMO_TRIGGER(BLE_Light, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Light, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Light, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Light, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(BatteryInfo, triggered):
		{
			ATMO_AbilityHandler(ATMO_ABILITY(BLE_Battery, setValue), value);
			break;
		}

		case ATMO_TRIGGER(BLE_Battery, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Battery, written):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Battery, subscibed):
		{
			break;
		}

		case ATMO_TRIGGER(BLE_Battery, unsubscribed):
		{
			break;
		}

		case ATMO_TRIGGER(Backlight, triggered):
		{
			break;
		}

		case ATMO_TRIGGER(Backlight, backlightSet):
		{
			break;
		}

	}

}

#ifdef __cplusplus
}
#endif
