
#ifndef ATMO_TRIGGER_HANDLER_H
#define ATMO_TRIGGER_HANDLER_H

#include "atmosphere_platform.h"
#include "../atmo/core.h"

#ifdef __cplusplus
	extern "C"{
#endif

#define ATMO_TRIGGER(ELEMENT, NAME) ATMO_ ## ELEMENT ## _TRIGGER_  ## NAME

void ATMO_TriggerHandler(unsigned int triggerHandleId, ATMO_Value_t *value);

#define ATMO_Interval_TRIGGER_triggered 0x1
#define ATMO_Interval_TRIGGER_interval 0x2
#define ATMO_BLE_TVOC_TRIGGER_triggered 0x3
#define ATMO_BLE_TVOC_TRIGGER_written 0x4
#define ATMO_BLE_TVOC_TRIGGER_subscibed 0x5
#define ATMO_BLE_TVOC_TRIGGER_unsubscribed 0x6
#define ATMO_AirQuality_TVOC_TRIGGER_triggered 0x7
#define ATMO_AirQuality_TVOC_TRIGGER_TVOCRead 0x8
#define ATMO_AirQuality_TVOC_TRIGGER_CO2Read 0x9
#define ATMO_AirQuality_CO2_TRIGGER_triggered 0xa
#define ATMO_AirQuality_CO2_TRIGGER_TVOCRead 0xb
#define ATMO_AirQuality_CO2_TRIGGER_CO2Read 0xc
#define ATMO_BLE_CO2_TRIGGER_triggered 0xd
#define ATMO_BLE_CO2_TRIGGER_written 0xe
#define ATMO_BLE_CO2_TRIGGER_subscibed 0xf
#define ATMO_BLE_CO2_TRIGGER_unsubscribed 0x10
#define ATMO_Pressure_TRIGGER_triggered 0x11
#define ATMO_Pressure_TRIGGER_altitudeRead 0x12
#define ATMO_Pressure_TRIGGER_pressureRead 0x13
#define ATMO_Pressure_TRIGGER_pressureReadKpa 0x14
#define ATMO_BLE_Pressure_TRIGGER_triggered 0x15
#define ATMO_BLE_Pressure_TRIGGER_written 0x16
#define ATMO_BLE_Pressure_TRIGGER_subscibed 0x17
#define ATMO_BLE_Pressure_TRIGGER_unsubscribed 0x18
#define ATMO_Temperature_TRIGGER_triggered 0x19
#define ATMO_Temperature_TRIGGER_temperatureRead 0x1a
#define ATMO_Temperature_TRIGGER_humidityRead 0x1b
#define ATMO_BLE_Temperature_TRIGGER_triggered 0x1c
#define ATMO_BLE_Temperature_TRIGGER_written 0x1d
#define ATMO_BLE_Temperature_TRIGGER_subscibed 0x1e
#define ATMO_BLE_Temperature_TRIGGER_unsubscribed 0x1f
#define ATMO_Humidity_TRIGGER_triggered 0x20
#define ATMO_Humidity_TRIGGER_temperatureRead 0x21
#define ATMO_Humidity_TRIGGER_humidityRead 0x22
#define ATMO_BLE_Humidity_TRIGGER_triggered 0x23
#define ATMO_BLE_Humidity_TRIGGER_written 0x24
#define ATMO_BLE_Humidity_TRIGGER_subscibed 0x25
#define ATMO_BLE_Humidity_TRIGGER_unsubscribed 0x26
#define ATMO_AmbientLight_TRIGGER_triggered 0x27
#define ATMO_AmbientLight_TRIGGER_ambientLightRead 0x28
#define ATMO_BLE_Light_TRIGGER_triggered 0x29
#define ATMO_BLE_Light_TRIGGER_written 0x2a
#define ATMO_BLE_Light_TRIGGER_subscibed 0x2b
#define ATMO_BLE_Light_TRIGGER_unsubscribed 0x2c
#define ATMO_BatteryInfo_TRIGGER_triggered 0x2d
#define ATMO_BLE_Battery_TRIGGER_triggered 0x2e
#define ATMO_BLE_Battery_TRIGGER_written 0x2f
#define ATMO_BLE_Battery_TRIGGER_subscibed 0x30
#define ATMO_BLE_Battery_TRIGGER_unsubscribed 0x31
#define ATMO_Backlight_TRIGGER_triggered 0x32
#define ATMO_Backlight_TRIGGER_backlightSet 0x33
#ifdef __cplusplus
}
#endif
#endif
